

function table_count(tt, item) -- To count doubles in a table
  local count
  count = 0
  for ii,xx in pairs(tt) do
    if item == xx then count = count + 1 end
  end
  return count
end

function table_unique(tt)-- to remove remove doubles in a table
            local newtable
            newtable = {}
            for ii,xx in ipairs(tt) do
            if(table_count(newtable, xx) == 0) then
            newtable[#newtable+1] = xx
            end
            end
            return newtable
            end
			
function smallestAngleDiff( target, source )
   local a = target - source
   
   if (a > 180) then
      a = a - 360
   elseif (a < -180) then
      a = a + 360
   end
   
   return a
end

   

function CASattack(CAStarget,CASgroup)  -- attack task for CAS flights

	local _groupID = Group.getByName(tostring(CAStarget)):getID()					
									
					 AttackGroup = { 
					 
						id = 'AttackGroup',
						params = {
							 groupId = _groupID,
							 weaponType = nil,
							 expend = nil,
							 attackQty = nil,
							 directionEnabled = false,
							 direction = nil,
							 altitudeEnabled = false,
							 altitude = nil,
							 attackQtyLimit = nil,
							}
					}	
				_group = Group.getByName(tostring(CASgroup))
				_controller = _group:getController()
				_controller:pushTask(AttackGroup);

				trigger.action.outText(tostring(CASgroup) .. " engaging units in zone", 30) 
				
end				
			
function CASstop(CASgroup)		-- stop attack of CAS flights and back to oringinal route
		
	mist.goRoute(CASgroup, mist.getGroupRoute(CASgroup, true)) 
	trigger.action.outText(tostring(CASgroup) .. " cancelling attack", 30)
end

function addmenus()-- Add menus to F10
		
		_path30 = missionCommands.addSubMenuForCoalition(coalition.side.BLUE,"CAS Support from Recon Helo", nil)
		-- Recon menu

		missionCommands.addCommandForCoalition(coalition.side.BLUE, "Load Target from Recon Helo",_path30, function ()LoadTargetForCASblueGazelle() end, nil)
		missionCommands.addCommandForCoalition(coalition.side.BLUE, "Reset targets for CAS Gazelle",_path30, function () deleteCASmenus() end, nil)
	end
		

function deleteCASmenus() -- reset F10 so when you want to load more groups, and you are running out of F commands.
missionCommands.removeItemForCoalition(coalition.side.BLUE,_path30, nil)
addmenus()
end

function LoadTargetForCASblueGazelle() --- load targets in the menu F10
	local reconhelo = 'espia1'
	local redunits = mist.makeUnitTable({'[red][vehicle]'})
	local unitheading = mist.makeUnitTable({'espia1'})
	local LOSData = mist.getUnitsLOS(unitheading,2,redunits,2,15000)
	
	local Gaz_targets = {}
		for k, v in pairs (LOSData) do
			local tabledata = LOSData[k]
			for j, w in pairs (tabledata.vis)do            
				local targetinLOS = tabledata.vis[j]
				Gaz_targets[#Gaz_targets+1] = targetinLOS
			end
		end
    
    local Gaz_targetgrouptable = {} -- table with all units-groups    
        
    for k, v in pairs(Gaz_targets) do
         local unit = Gaz_targets[k]
         local unitname = unit:getGroup()
            Gaz_targetgrouptable[#Gaz_targetgrouptable+1] = unitname         
    end         

	_path34 = missionCommands.addSubMenuForCoalition(coalition.side.BLUE,"CAS1", _path30)
	_path35 = missionCommands.addSubMenuForCoalition(coalition.side.BLUE,"CAS2", _path30)
	_path36 = missionCommands.addSubMenuForCoalition(coalition.side.BLUE,"CAS3", _path30)
	_path37 = missionCommands.addSubMenuForCoalition(coalition.side.BLUE,"CAS4", _path30)
		missionCommands.addCommandForCoalition(coalition.side.BLUE,"CAS1 cancel attack", _path34, function ()CASstop("CAS1")end, nil)
		missionCommands.addCommandForCoalition(coalition.side.BLUE,"CAS2 cancel attack", _path35, function ()CASstop("CAS2")end, nil)
		missionCommands.addCommandForCoalition(coalition.side.BLUE,"CAS3 cancel attack", _path36, function ()CASstop("CAS3")end, nil)
		missionCommands.addCommandForCoalition(coalition.side.BLUE,"CAS4 cancel attack", _path37, function ()CASstop("CAS4")end, nil)

	local Gaz_tabletarget = table_unique(Gaz_targetgrouptable)    -- all duplicated groups removed
	
   		
    for k, v in pairs(Gaz_tabletarget) do
		local group = Gaz_tabletarget[k]
	
								local Gaz_position = mist.utils.makeVec2(Unit.getByName(reconhelo):getPosition().p)-- tenemos un vector x e y
								local Gaz_heading = mist.utils.toDegree(mist.getHeading(Unit.getByName(reconhelo)))
							--trigger.action.outText(Gaz_heading,20)
							--trigger.action.outText(mist.utils.tableShow(Gaz_position),20)
								local leaderpos = mist.utils.makeVec2(mist.getLeadPos(group))
							--trigger.action.outText(mist.utils.tableShow(leaderpos),20)
								local GroupBearing = mist.utils.toDegree(mist.utils.getDir(mist.vec.sub(mist.utils.makeVec3GL(leaderpos),mist.utils.makeVec3GL(Gaz_position))))
							--trigger.action.outText(GroupBearing,20)

								local offsetangle = smallestAngleDiff((GroupBearing - 6), Gaz_heading )
								--trigger.action.outText(offsetangle,20)


			if offsetangle <= 8 and offsetangle >= -8
			then 
		
		trigger.action.outText("ready to copy",20)								
          local groupname = group:getName()		  
		  local targetgrouppos = mist.getLLString({units = mist.makeUnitTable{tostring('[g]'.. groupname)} , acc = 2,})
        missionCommands.addCommandForCoalition(coalition.side.BLUE,"CAS1 " .. targetgrouppos, _path34, function ()CASattack(tostring(groupname),"CAS1")end, nil)
		missionCommands.addCommandForCoalition(coalition.side.BLUE,"CAS2 " .. targetgrouppos, _path35, function ()CASattack(tostring(groupname),"CAS2")end, nil)
		missionCommands.addCommandForCoalition(coalition.side.BLUE,"CAS3 " .. targetgrouppos, _path36, function ()CASattack(tostring(groupname),"CAS3")end, nil)
		missionCommands.addCommandForCoalition(coalition.side.BLUE,"CAS4 " .. targetgrouppos, _path37, function ()CASattack(tostring(groupname),"CAS4")end, nil)
			else	
			trigger.action.outText("not aligned",20)
			end
	end
end

addmenus()
